﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace OperationsConsole
{
    public partial class OperationsConsole : Form
    {
        public OperationsConsole()
        {
            InitializeComponent();
        }

        private void buttonAzureTestConnection_Click(object sender, EventArgs e)
        {
            //MessageLowLevel.CreateQueue();
            if(MessageLowLevel.TestQueue())
            {
                textBoxAzureTestStatus.Text = "Azure Connection Verified";
            }
            else
            {
                textBoxAzureTestStatus.Text = "Azure Connection Problem";
            }
        }


        AzureReader _azureReader = new AzureReader();
        Thread _readThread = null;

        private void buttonStartReadThread_Click(object sender, EventArgs e)
        {
            if (_readThread == null)
            {
                _readThread = new Thread(new ThreadStart(_azureReader.ContinuousRead));
                _readThread.Start();
                buttonStartReadThread.Text = "Stop Read Thread";
                buttonAzureTestConnection.Enabled = false;
            }
            else
            {
                _azureReader.PleaseStop = true;
                // might take some time
                _readThread.Join();
                buttonStartReadThread.Text = "Start Read Thread";
                buttonAzureTestConnection.Enabled = true;
            }
        }

        private void timerRead_Tick(object sender, EventArgs e)
        {
            if(_azureReader.LocalQueue.Count > 0)
            {
                textBoxSensorTagStatus.Text = _azureReader.LocalQueue.Dequeue();
                textBoxSensorTagUpdateTime.Text = DateTime.Now.ToString();
            }
        }
    }
}
